/*******************************************************
*        Trabalho de Inteligncia Artificial           *
*             Anderson de Rezende Rocha                *
*                 Jlio Csar Alves                    * 
*******************************************************/

#ifndef PONTO_H
#define PONTO_H

#include <math.h>

class clPonto
{
    public:
        // Construtor padro de um ponto
        clPonto(int umX = 0, int umY = 0) { Set(umX, umY); }
        ~clPonto(){}

        // Retorna o valor x,y de um determinado ponto
        int GetX() { return x; }
        int GetY() { return y; }

        // Seta o valor x,y de um dado ponto
        void SetX(int umX) { x = umX; }
        void SetY(int umY) { y = umY; }
        void Set(int umX, int umY) { SetX(umX); SetY(umY); }

        // Calcula distncia entre dois pontos
        double CalculaDistancia(clPonto p)
        {
            // Frmula matemtica de distncia entre dois pontos
            return sqrt( pow((GetX() - p.GetX()), 2) + pow( (GetY() - p.GetY()),2) );
        }

        // Verifica se o ponto esta no quadrado de lado = 2*raio+1
        // cujo centro eh o ponto p
        bool PertenceARegiao(clPonto p, int raio)
        {
            return ( GetX() >= p.GetX()-raio && GetY() >= p.GetY()-raio &&
                     GetX() <= p.GetX()+raio && GetY() <= p.GetY()+raio    );
        }

        void operator=(clPonto p) { x = p.x; y = p.y; }
        bool operator==(clPonto p) { return (x == p.x && y == p.y); }

    private:
        int x;
        int y;
};

#endif

