/*******************************************************
*        Trabalho de Inteligncia Artificial           *
*             Anderson de Rezende Rocha                *
*                 Jlio Csar Alves                    * 
*******************************************************/

#ifndef STATUS_FRAME_H
#define STATUS_FRAME_H

class robosMineradores;

// Exibe uma caixa de texto para acompanhar tudo o que est acontecendo no modo 
// grfico
class statusFrame: public wxFrame
{
    public:
        // Construtor e destrutor
        statusFrame();
        // Destrutor
        ~statusFrame();

        // Permite a criao de um novo frame de status
        void NovoStatus(wxString str);
        // Listener para o evento de saida
        void OnExit(wxCloseEvent& event);

   private:
        // Referncia ao status
        wxTextCtrl *status;
        // Referncia ao componente pai
        robosMineradores *pai;

        DECLARE_DYNAMIC_CLASS(statusFrame)
        DECLARE_EVENT_TABLE()
};


IMPLEMENT_DYNAMIC_CLASS(statusFrame, wxFrame)

BEGIN_EVENT_TABLE(statusFrame, wxFrame)
    EVT_CLOSE(statusFrame::OnExit)
END_EVENT_TABLE()


// Mostra o frame na tela
statusFrame::statusFrame()
        : wxFrame((wxFrame *)NULL, -1, "Status", wxDefaultPosition, wxSize(300, 400))
{
    status = new wxTextCtrl(this, -1, "Estado da Simulao", wxPoint(0, 0),
                            wxSize(300, 400), wxTE_MULTILINE | wxTE_READONLY);
}

statusFrame::~statusFrame()
{
    delete status;
}

// Abrindo nova tela
void statusFrame::NovoStatus(wxString str)
{
    status->SetValue(str);
}

// Saindo do frame
void statusFrame::OnExit(wxCloseEvent& event)
{
    Show(false);
}

#endif

